`timescale 1ns/1ps

`include "if_wb_master.svh"
`include "if_wb_slave.svh"
import wishbone_pkg::*;


`define WIRE_WRF_SRC(dst, src) \
assign dst``_o.cyc = src.cyc; \
assign dst``_o.stb = src.stb; \
assign dst``_o.adr = src.adr; \
assign dst``_o.dat = src.dat_o; \
assign dst``_o.sel = src.sel; \
assign dst``_o.we  = src.we; \
assign src.ack = dst``_i.ack; \
assign src.dat_i = dst``_i.dat; \
assign src.err = dst``_i.err; \
assign src.stall = dst``_i.stall;


module main;

	reg clk_ref = 1'b0;
	reg rst_n		= 1'b0;
	reg rst_naux= 1'b1;
	reg pps			= 1'b0;
	reg pps_valid	= 1'b0;

	IWishboneMaster #(32,32) sv_wbm (clk_ref, rst_n);
	t_wishbone_master_out wbm_o;
	t_wishbone_master_in  wbm_i;
	`WIRE_WRF_SRC(wbm, sv_wbm);

  always #8ns clk_ref <= ~clk_ref;
  initial begin
    repeat(3) @(posedge clk_ref);
    rst_n <= 1'b1;
		//#90us
		//rst_n <= 1'b0;
    //repeat(3) @(posedge clk_ref);
		//rst_n <= 1'b1;
  end

	//always begin
	//	#90us
	//	rst_naux <= 1'b0;
	//	repeat(3) @(posedge clk_ref);
	//	rst_naux <= 1'b1;
	//end

	initial begin
		pps_valid <= 1'b0;
		#20us
		pps_valid <= 1'b1;
	end
	always begin
		#39us;
		#984ns;
		pps <= 1'b1;
		#16ns;
		pps <= 1'b0;
	end 

	wrsw_rt_subsystem 
	#(
		.g_num_rx_clocks(1),
		.g_simulation(1)) DUT
	(
		.clk_ref_i(clk_ref),
		.clk_sys_i(clk_ref),
		.clk_dmtd_i(clk_ref),
		.clk_rx_i(1'b0),
		.clk_ext_i(1'b0),
		.clk_ext_mul_i(1'b0),
		.rst_n_i(rst_n),

		.wb_i(wbm_o),
		.wb_o(wbm_i),
		.uart_rxd_i(1'b0),
		
		.pps_ext_i(1'b0),
		.pll_status_i(1'b0),
		.pll_miso_i(1'b0)
	);

	initial begin
		CWishboneAccessor acc;
		uint64_t dat;
		acc = sv_wbm.get_accessor();
		acc.set_mode(PIPELINED);
		#1us;
		//no more reset for ppsgen
		acc.write('h10304*4, 'h8);
		acc.write('h10500*4, 'h2);
		acc.write('h1051c*4, 'h2);
		#100us;
		acc.write('h10520*4, 'h04);
		acc.read('h10520*4, dat);
	end

endmodule
